#include <AccelStepper.h>

AccelStepper stepper (1, 8, 9);//driver, step, direction  RPM
AccelStepper stepper1 (1, 10, 11);//driver, step, direction FUEL
AccelStepper stepper2 (1, 6, 7);//driver, step, direction  Speed

unsigned int rpm;           // holds the rpm data (0-65535 size)
unsigned int carspeed;      // holds the rpm data (0-65535 size)
unsigned int gear;          // holds the rpm data (0-65535 size)
unsigned int fuel;          // holds the rpm data (0-65535 size)


void setup() 
{
  Serial.begin(115200);

  stepper.setMaxSpeed(10000);          
  stepper.setAcceleration(360000);     
  stepper.runToNewPosition(-3780);     
                         
  stepper1.setMaxSpeed(10000);         
  stepper1.setAcceleration(360000);   
  stepper1.runToNewPosition(-3780);    
  
  stepper2.setMaxSpeed(10000);         
  stepper2.setAcceleration(360000);   
  stepper2.runToNewPosition(-3780);    
                         
  stepper.run();                       
  stepper1.run();  
  stepper2.run();  
                         
  stepper.setCurrentPosition(0);       
  stepper1.setCurrentPosition(0);    
  stepper2.setCurrentPosition(0);  
}

void loop() 
{
  readSerialData();
  
  stepper.moveTo(rpm); 
  stepper1.moveTo(fuel); 
  stepper2.moveTo(carspeed); 
  
  stepper.run();
  stepper1.run();
  stepper2.run();
}

void readSerialData()
{
  byte Data[5]={'0','0','0','0','0'};

  // parse the buffer
  if (Serial.available()>4)
  {
    Data[0]=Serial.read();                   
    if (Data[0]=='R')
    {                                         
      Data[1]=Serial.read();                 
      Data[2]=Serial.read();                 
      Data[3]=Serial.read();                 
      Data[4]=Serial.read(); 
      
      rpm = NormalizeData(Data);
      rpm = map(rpm,0,10000,0,3200);
      //rpmdata=1;                      

      if (Serial.available()>4)
      {
        Data[0]=Serial.read();               
      }
    }
    
     if (Data[0] == 'S' )
     {                   
      Data[1]=Serial.read();                 
      Data[2]=Serial.read();                 
      Data[3]=Serial.read();                
      Data[4]=Serial.read(); 
    
      carspeed = NormalizeData(Data);
      carspeed = map(carspeed,0,250,0,1500);
      //speeddata=1;    
      
      if (Serial.available()>4)
      {
        Data[0]=Serial.read();               
      }
    }
    
      if (Data[0] == 'G' )
      {                    
      Data[1]=Serial.read();                 
      Data[2]=Serial.read();                 
      Data[3]=Serial.read();                
      Data[4]=Serial.read(); 
      
      gear = NormalizeData(Data);
      //geardata=1;                            

      if (Serial.available()>4)
      {
        Data[0]=Serial.read();               
      }
    } 
    
      if (Data[0] == 'F' )
      {                    
      Data[1]=Serial.read();                 
      Data[2]=Serial.read();                 
      Data[3]=Serial.read();                
      Data[4]=Serial.read(); 
      
      fuel = NormalizeData(Data);
      fuel = map(fuel,0,60,0,3780);
      //fueldata=1;                            

      if (Serial.available()>4)
      {
        Data[0]=Serial.read();               
      }
    }                 

      if (Data[0] == 'Z' )
      {                     
        Serial.flush();
      }             
    }
  if (Serial.available()>20) Serial.flush();
}
 ////////////////////////////////////////////////////////////////////////////////
// Function: convert Hex to Dec
////////////////////////////////////////////////////////////////////////////////
unsigned int NormalizeData(byte x[5])
////////////////////////////////////////////////////////////////////////////////
{
unsigned int result;

for (int i=1; i<5; i++)
{
if (x[i]>47 && x[i]<58 ){   //for xA to xF
x[i]=x[i]-48;
}                       
if (  x[i]>64 && x[i]<71 ){ //for x0 to x9
x[i]=x[i]-55;               
}
}    
result = (x[1]*16*16*16+x[2]*16*16+x[3]*16+x[4]);
return result;
} 
